// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:action/TrackPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__STRUCT_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'follow_path'
#include "kompass_interfaces/msg/detail/follow_path_request__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_Goal __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_Goal __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_Goal_
{
  using Type = TrackPath_Goal_<ContainerAllocator>;

  explicit TrackPath_Goal_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : follow_path(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_of_cmds = 0l;
      this->time_step = 0.0;
    }
  }

  explicit TrackPath_Goal_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : follow_path(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_of_cmds = 0l;
      this->time_step = 0.0;
    }
  }

  // field types and members
  using _number_of_cmds_type =
    int32_t;
  _number_of_cmds_type number_of_cmds;
  using _time_step_type =
    double;
  _time_step_type time_step;
  using _follow_path_type =
    kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>;
  _follow_path_type follow_path;

  // setters for named parameter idiom
  Type & set__number_of_cmds(
    const int32_t & _arg)
  {
    this->number_of_cmds = _arg;
    return *this;
  }
  Type & set__time_step(
    const double & _arg)
  {
    this->time_step = _arg;
    return *this;
  }
  Type & set__follow_path(
    const kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> & _arg)
  {
    this->follow_path = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_Goal
    std::shared_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_Goal
    std::shared_ptr<kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_Goal_ & other) const
  {
    if (this->number_of_cmds != other.number_of_cmds) {
      return false;
    }
    if (this->time_step != other.time_step) {
      return false;
    }
    if (this->follow_path != other.follow_path) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_Goal_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_Goal_

// alias to use template instance with default allocator
using TrackPath_Goal =
  kompass_interfaces::action::TrackPath_Goal_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'tracking_error'
#include "kompass_interfaces/msg/detail/path_tracking_error__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_Result __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_Result __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_Result_
{
  using Type = TrackPath_Result_<ContainerAllocator>;

  explicit TrackPath_Result_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : tracking_error(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->reached_end = false;
    }
  }

  explicit TrackPath_Result_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : tracking_error(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->reached_end = false;
    }
  }

  // field types and members
  using _reached_end_type =
    bool;
  _reached_end_type reached_end;
  using _tracking_error_type =
    kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>;
  _tracking_error_type tracking_error;

  // setters for named parameter idiom
  Type & set__reached_end(
    const bool & _arg)
  {
    this->reached_end = _arg;
    return *this;
  }
  Type & set__tracking_error(
    const kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> & _arg)
  {
    this->tracking_error = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_Result_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_Result_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_Result_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_Result_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_Result
    std::shared_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_Result
    std::shared_ptr<kompass_interfaces::action::TrackPath_Result_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_Result_ & other) const
  {
    if (this->reached_end != other.reached_end) {
      return false;
    }
    if (this->tracking_error != other.tracking_error) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_Result_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_Result_

// alias to use template instance with default allocator
using TrackPath_Result =
  kompass_interfaces::action::TrackPath_Result_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'cmd_list'
#include "kompass_interfaces/msg/detail/twist_array__struct.hpp"
// Member 'global_path'
#include "nav_msgs/msg/detail/path__struct.hpp"
// Member 'tracking_errors'
#include "kompass_interfaces/msg/detail/path_tracking_error_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_Feedback __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_Feedback __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_Feedback_
{
  using Type = TrackPath_Feedback_<ContainerAllocator>;

  explicit TrackPath_Feedback_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cmd_list(_init),
    global_path(_init),
    tracking_errors(_init)
  {
    (void)_init;
  }

  explicit TrackPath_Feedback_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cmd_list(_alloc, _init),
    global_path(_alloc, _init),
    tracking_errors(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _cmd_list_type =
    kompass_interfaces::msg::TwistArray_<ContainerAllocator>;
  _cmd_list_type cmd_list;
  using _global_path_type =
    nav_msgs::msg::Path_<ContainerAllocator>;
  _global_path_type global_path;
  using _tracking_errors_type =
    kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator>;
  _tracking_errors_type tracking_errors;

  // setters for named parameter idiom
  Type & set__cmd_list(
    const kompass_interfaces::msg::TwistArray_<ContainerAllocator> & _arg)
  {
    this->cmd_list = _arg;
    return *this;
  }
  Type & set__global_path(
    const nav_msgs::msg::Path_<ContainerAllocator> & _arg)
  {
    this->global_path = _arg;
    return *this;
  }
  Type & set__tracking_errors(
    const kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator> & _arg)
  {
    this->tracking_errors = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_Feedback
    std::shared_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_Feedback
    std::shared_ptr<kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_Feedback_ & other) const
  {
    if (this->cmd_list != other.cmd_list) {
      return false;
    }
    if (this->global_path != other.global_path) {
      return false;
    }
    if (this->tracking_errors != other.tracking_errors) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_Feedback_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_Feedback_

// alias to use template instance with default allocator
using TrackPath_Feedback =
  kompass_interfaces::action::TrackPath_Feedback_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
#include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'goal'
#include "kompass_interfaces/action/detail/track_path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_SendGoal_Request_
{
  using Type = TrackPath_SendGoal_Request_<ContainerAllocator>;

  explicit TrackPath_SendGoal_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    goal(_init)
  {
    (void)_init;
  }

  explicit TrackPath_SendGoal_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    goal(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _goal_type =
    kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator>;
  _goal_type goal;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__goal(
    const kompass_interfaces::action::TrackPath_Goal_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Request
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_SendGoal_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_SendGoal_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_SendGoal_Request_

// alias to use template instance with default allocator
using TrackPath_SendGoal_Request =
  kompass_interfaces::action::TrackPath_SendGoal_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_SendGoal_Response_
{
  using Type = TrackPath_SendGoal_Response_<ContainerAllocator>;

  explicit TrackPath_SendGoal_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  explicit TrackPath_SendGoal_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : stamp(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->accepted = false;
    }
  }

  // field types and members
  using _accepted_type =
    bool;
  _accepted_type accepted;
  using _stamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _stamp_type stamp;

  // setters for named parameter idiom
  Type & set__accepted(
    const bool & _arg)
  {
    this->accepted = _arg;
    return *this;
  }
  Type & set__stamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->stamp = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_SendGoal_Response
    std::shared_ptr<kompass_interfaces::action::TrackPath_SendGoal_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_SendGoal_Response_ & other) const
  {
    if (this->accepted != other.accepted) {
      return false;
    }
    if (this->stamp != other.stamp) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_SendGoal_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_SendGoal_Response_

// alias to use template instance with default allocator
using TrackPath_SendGoal_Response =
  kompass_interfaces::action::TrackPath_SendGoal_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct TrackPath_SendGoal
{
  using Request = kompass_interfaces::action::TrackPath_SendGoal_Request;
  using Response = kompass_interfaces::action::TrackPath_SendGoal_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_GetResult_Request_
{
  using Type = TrackPath_GetResult_Request_<ContainerAllocator>;

  explicit TrackPath_GetResult_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init)
  {
    (void)_init;
  }

  explicit TrackPath_GetResult_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Request
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_GetResult_Request_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_GetResult_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_GetResult_Request_

// alias to use template instance with default allocator
using TrackPath_GetResult_Request =
  kompass_interfaces::action::TrackPath_GetResult_Request_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'result'
// already included above
// #include "kompass_interfaces/action/detail/track_path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_GetResult_Response_
{
  using Type = TrackPath_GetResult_Response_<ContainerAllocator>;

  explicit TrackPath_GetResult_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  explicit TrackPath_GetResult_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : result(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
    }
  }

  // field types and members
  using _status_type =
    int8_t;
  _status_type status;
  using _result_type =
    kompass_interfaces::action::TrackPath_Result_<ContainerAllocator>;
  _result_type result;

  // setters for named parameter idiom
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__result(
    const kompass_interfaces::action::TrackPath_Result_<ContainerAllocator> & _arg)
  {
    this->result = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_GetResult_Response
    std::shared_ptr<kompass_interfaces::action::TrackPath_GetResult_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_GetResult_Response_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->result != other.result) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_GetResult_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_GetResult_Response_

// alias to use template instance with default allocator
using TrackPath_GetResult_Response =
  kompass_interfaces::action::TrackPath_GetResult_Response_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace action
{

struct TrackPath_GetResult
{
  using Request = kompass_interfaces::action::TrackPath_GetResult_Request;
  using Response = kompass_interfaces::action::TrackPath_GetResult_Response;
};

}  // namespace action

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'goal_id'
// already included above
// #include "unique_identifier_msgs/msg/detail/uuid__struct.hpp"
// Member 'feedback'
// already included above
// #include "kompass_interfaces/action/detail/track_path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__action__TrackPath_FeedbackMessage __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__action__TrackPath_FeedbackMessage __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace action
{

// message struct
template<class ContainerAllocator>
struct TrackPath_FeedbackMessage_
{
  using Type = TrackPath_FeedbackMessage_<ContainerAllocator>;

  explicit TrackPath_FeedbackMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_init),
    feedback(_init)
  {
    (void)_init;
  }

  explicit TrackPath_FeedbackMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : goal_id(_alloc, _init),
    feedback(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _goal_id_type =
    unique_identifier_msgs::msg::UUID_<ContainerAllocator>;
  _goal_id_type goal_id;
  using _feedback_type =
    kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator>;
  _feedback_type feedback;

  // setters for named parameter idiom
  Type & set__goal_id(
    const unique_identifier_msgs::msg::UUID_<ContainerAllocator> & _arg)
  {
    this->goal_id = _arg;
    return *this;
  }
  Type & set__feedback(
    const kompass_interfaces::action::TrackPath_Feedback_<ContainerAllocator> & _arg)
  {
    this->feedback = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__action__TrackPath_FeedbackMessage
    std::shared_ptr<kompass_interfaces::action::TrackPath_FeedbackMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const TrackPath_FeedbackMessage_ & other) const
  {
    if (this->goal_id != other.goal_id) {
      return false;
    }
    if (this->feedback != other.feedback) {
      return false;
    }
    return true;
  }
  bool operator!=(const TrackPath_FeedbackMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct TrackPath_FeedbackMessage_

// alias to use template instance with default allocator
using TrackPath_FeedbackMessage =
  kompass_interfaces::action::TrackPath_FeedbackMessage_<std::allocator<void>>;

// constant definitions

}  // namespace action

}  // namespace kompass_interfaces

#include "action_msgs/srv/cancel_goal.hpp"
#include "action_msgs/msg/goal_info.hpp"
#include "action_msgs/msg/goal_status_array.hpp"

namespace kompass_interfaces
{

namespace action
{

struct TrackPath
{
  /// The goal message defined in the action definition.
  using Goal = kompass_interfaces::action::TrackPath_Goal;
  /// The result message defined in the action definition.
  using Result = kompass_interfaces::action::TrackPath_Result;
  /// The feedback message defined in the action definition.
  using Feedback = kompass_interfaces::action::TrackPath_Feedback;

  struct Impl
  {
    /// The send_goal service using a wrapped version of the goal message as a request.
    using SendGoalService = kompass_interfaces::action::TrackPath_SendGoal;
    /// The get_result service using a wrapped version of the result message as a response.
    using GetResultService = kompass_interfaces::action::TrackPath_GetResult;
    /// The feedback message with generic fields which wraps the feedback message.
    using FeedbackMessage = kompass_interfaces::action::TrackPath_FeedbackMessage;

    /// The generic service to cancel a goal.
    using CancelGoalService = action_msgs::srv::CancelGoal;
    /// The generic message for the status of a goal.
    using GoalStatusMessage = action_msgs::msg::GoalStatusArray;
  };
};

typedef struct TrackPath TrackPath;

}  // namespace action

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__TRACK_PATH__STRUCT_HPP_
