// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:msg/MotionStatus.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__STRUCT_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__msg__MotionStatus __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__msg__MotionStatus __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MotionStatus_
{
  using Type = MotionStatus_<ContainerAllocator>;

  explicit MotionStatus_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
      this->message = "";
    }
  }

  explicit MotionStatus_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : message(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->status = 0;
      this->message = "";
    }
  }

  // field types and members
  using _status_type =
    uint8_t;
  _status_type status;
  using _message_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _message_type message;

  // setters for named parameter idiom
  Type & set__status(
    const uint8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__message(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->message = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t STATUS_HEALTHY =
    0u;
  static constexpr uint8_t STATUS_FREEZING_ROBOT =
    1u;
  static constexpr uint8_t STATUS_LOW_LEVEL_ERROR =
    2u;
  static constexpr uint8_t STATUS_CONTROLLER_ERROR =
    3u;
  static constexpr uint8_t STATUS_PATH_FOLLOWER_ERROR =
    4u;
  static constexpr uint8_t STATUS_ODOMETRY_NOT_RECEIVED =
    5u;

  // pointer types
  using RawPtr =
    kompass_interfaces::msg::MotionStatus_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::msg::MotionStatus_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::MotionStatus_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::MotionStatus_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__msg__MotionStatus
    std::shared_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__msg__MotionStatus
    std::shared_ptr<kompass_interfaces::msg::MotionStatus_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MotionStatus_ & other) const
  {
    if (this->status != other.status) {
      return false;
    }
    if (this->message != other.message) {
      return false;
    }
    return true;
  }
  bool operator!=(const MotionStatus_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MotionStatus_

// alias to use template instance with default allocator
using MotionStatus =
  kompass_interfaces::msg::MotionStatus_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MotionStatus_<ContainerAllocator>::STATUS_HEALTHY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MotionStatus_<ContainerAllocator>::STATUS_FREEZING_ROBOT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MotionStatus_<ContainerAllocator>::STATUS_LOW_LEVEL_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MotionStatus_<ContainerAllocator>::STATUS_CONTROLLER_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MotionStatus_<ContainerAllocator>::STATUS_PATH_FOLLOWER_ERROR;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t MotionStatus_<ContainerAllocator>::STATUS_ODOMETRY_NOT_RECEIVED;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__STRUCT_HPP_
