// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:msg/MotionStatus.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__TRAITS_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/msg/detail/motion_status__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const MotionStatus & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << ", ";
  }

  // member: message
  {
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const MotionStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status: ";
    rosidl_generator_traits::value_to_yaml(msg.status, out);
    out << "\n";
  }

  // member: message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "message: ";
    rosidl_generator_traits::value_to_yaml(msg.message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const MotionStatus & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::msg::MotionStatus & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::msg::MotionStatus & msg)
{
  return kompass_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::msg::MotionStatus>()
{
  return "kompass_interfaces::msg::MotionStatus";
}

template<>
inline const char * name<kompass_interfaces::msg::MotionStatus>()
{
  return "kompass_interfaces/msg/MotionStatus";
}

template<>
struct has_fixed_size<kompass_interfaces::msg::MotionStatus>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<kompass_interfaces::msg::MotionStatus>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<kompass_interfaces::msg::MotionStatus>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__MOTION_STATUS__TRAITS_HPP_
