// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:msg/PathTrackingError.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__STRUCT_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__msg__PathTrackingError __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__msg__PathTrackingError __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathTrackingError_
{
  using Type = PathTrackingError_<ContainerAllocator>;

  explicit PathTrackingError_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->orientation_error = 0.0;
      this->lateral_distance_error = 0.0;
    }
  }

  explicit PathTrackingError_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->orientation_error = 0.0;
      this->lateral_distance_error = 0.0;
    }
  }

  // field types and members
  using _orientation_error_type =
    double;
  _orientation_error_type orientation_error;
  using _lateral_distance_error_type =
    double;
  _lateral_distance_error_type lateral_distance_error;

  // setters for named parameter idiom
  Type & set__orientation_error(
    const double & _arg)
  {
    this->orientation_error = _arg;
    return *this;
  }
  Type & set__lateral_distance_error(
    const double & _arg)
  {
    this->lateral_distance_error = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__msg__PathTrackingError
    std::shared_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__msg__PathTrackingError
    std::shared_ptr<kompass_interfaces::msg::PathTrackingError_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathTrackingError_ & other) const
  {
    if (this->orientation_error != other.orientation_error) {
      return false;
    }
    if (this->lateral_distance_error != other.lateral_distance_error) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathTrackingError_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathTrackingError_

// alias to use template instance with default allocator
using PathTrackingError =
  kompass_interfaces::msg::PathTrackingError_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__STRUCT_HPP_
