// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from kompass_interfaces:msg/PathTrackingError.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__TRAITS_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "kompass_interfaces/msg/detail/path_tracking_error__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace kompass_interfaces
{

namespace msg
{

inline void to_flow_style_yaml(
  const PathTrackingError & msg,
  std::ostream & out)
{
  out << "{";
  // member: orientation_error
  {
    out << "orientation_error: ";
    rosidl_generator_traits::value_to_yaml(msg.orientation_error, out);
    out << ", ";
  }

  // member: lateral_distance_error
  {
    out << "lateral_distance_error: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_distance_error, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathTrackingError & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: orientation_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "orientation_error: ";
    rosidl_generator_traits::value_to_yaml(msg.orientation_error, out);
    out << "\n";
  }

  // member: lateral_distance_error
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "lateral_distance_error: ";
    rosidl_generator_traits::value_to_yaml(msg.lateral_distance_error, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathTrackingError & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace kompass_interfaces

namespace rosidl_generator_traits
{

[[deprecated("use kompass_interfaces::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const kompass_interfaces::msg::PathTrackingError & msg,
  std::ostream & out, size_t indentation = 0)
{
  kompass_interfaces::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use kompass_interfaces::msg::to_yaml() instead")]]
inline std::string to_yaml(const kompass_interfaces::msg::PathTrackingError & msg)
{
  return kompass_interfaces::msg::to_yaml(msg);
}

template<>
inline const char * data_type<kompass_interfaces::msg::PathTrackingError>()
{
  return "kompass_interfaces::msg::PathTrackingError";
}

template<>
inline const char * name<kompass_interfaces::msg::PathTrackingError>()
{
  return "kompass_interfaces/msg/PathTrackingError";
}

template<>
struct has_fixed_size<kompass_interfaces::msg::PathTrackingError>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<kompass_interfaces::msg::PathTrackingError>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<kompass_interfaces::msg::PathTrackingError>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR__TRAITS_HPP_
