// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kompass_interfaces:msg/PredictedOccupancies.idl
// generated code does not contain a copyright notice
#include "kompass_interfaces/msg/detail/predicted_occupancies__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `obstacles`
#include "kompass_interfaces/msg/detail/obstacles__functions.h"

bool
kompass_interfaces__msg__PredictedOccupancies__init(kompass_interfaces__msg__PredictedOccupancies * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    kompass_interfaces__msg__PredictedOccupancies__fini(msg);
    return false;
  }
  // start_time
  // horizon
  // time_step
  // obstacles
  if (!kompass_interfaces__msg__Obstacles__Sequence__init(&msg->obstacles, 0)) {
    kompass_interfaces__msg__PredictedOccupancies__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__msg__PredictedOccupancies__fini(kompass_interfaces__msg__PredictedOccupancies * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // start_time
  // horizon
  // time_step
  // obstacles
  kompass_interfaces__msg__Obstacles__Sequence__fini(&msg->obstacles);
}

bool
kompass_interfaces__msg__PredictedOccupancies__are_equal(const kompass_interfaces__msg__PredictedOccupancies * lhs, const kompass_interfaces__msg__PredictedOccupancies * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // start_time
  if (lhs->start_time != rhs->start_time) {
    return false;
  }
  // horizon
  if (lhs->horizon != rhs->horizon) {
    return false;
  }
  // time_step
  if (lhs->time_step != rhs->time_step) {
    return false;
  }
  // obstacles
  if (!kompass_interfaces__msg__Obstacles__Sequence__are_equal(
      &(lhs->obstacles), &(rhs->obstacles)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__msg__PredictedOccupancies__copy(
  const kompass_interfaces__msg__PredictedOccupancies * input,
  kompass_interfaces__msg__PredictedOccupancies * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // start_time
  output->start_time = input->start_time;
  // horizon
  output->horizon = input->horizon;
  // time_step
  output->time_step = input->time_step;
  // obstacles
  if (!kompass_interfaces__msg__Obstacles__Sequence__copy(
      &(input->obstacles), &(output->obstacles)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__msg__PredictedOccupancies *
kompass_interfaces__msg__PredictedOccupancies__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__PredictedOccupancies * msg = (kompass_interfaces__msg__PredictedOccupancies *)allocator.allocate(sizeof(kompass_interfaces__msg__PredictedOccupancies), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__msg__PredictedOccupancies));
  bool success = kompass_interfaces__msg__PredictedOccupancies__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__msg__PredictedOccupancies__destroy(kompass_interfaces__msg__PredictedOccupancies * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__msg__PredictedOccupancies__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__msg__PredictedOccupancies__Sequence__init(kompass_interfaces__msg__PredictedOccupancies__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__PredictedOccupancies * data = NULL;

  if (size) {
    data = (kompass_interfaces__msg__PredictedOccupancies *)allocator.zero_allocate(size, sizeof(kompass_interfaces__msg__PredictedOccupancies), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__msg__PredictedOccupancies__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__msg__PredictedOccupancies__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__msg__PredictedOccupancies__Sequence__fini(kompass_interfaces__msg__PredictedOccupancies__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__msg__PredictedOccupancies__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__msg__PredictedOccupancies__Sequence *
kompass_interfaces__msg__PredictedOccupancies__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__msg__PredictedOccupancies__Sequence * array = (kompass_interfaces__msg__PredictedOccupancies__Sequence *)allocator.allocate(sizeof(kompass_interfaces__msg__PredictedOccupancies__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__msg__PredictedOccupancies__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__msg__PredictedOccupancies__Sequence__destroy(kompass_interfaces__msg__PredictedOccupancies__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__msg__PredictedOccupancies__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__msg__PredictedOccupancies__Sequence__are_equal(const kompass_interfaces__msg__PredictedOccupancies__Sequence * lhs, const kompass_interfaces__msg__PredictedOccupancies__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__msg__PredictedOccupancies__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__msg__PredictedOccupancies__Sequence__copy(
  const kompass_interfaces__msg__PredictedOccupancies__Sequence * input,
  kompass_interfaces__msg__PredictedOccupancies__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__msg__PredictedOccupancies);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__msg__PredictedOccupancies * data =
      (kompass_interfaces__msg__PredictedOccupancies *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__msg__PredictedOccupancies__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__msg__PredictedOccupancies__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__msg__PredictedOccupancies__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
