// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:srv/GetCmdList.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__GET_CMD_LIST__STRUCT_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__GET_CMD_LIST__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'follow_path'
#include "kompass_interfaces/msg/detail/follow_path_request__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__GetCmdList_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__GetCmdList_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetCmdList_Request_
{
  using Type = GetCmdList_Request_<ContainerAllocator>;

  explicit GetCmdList_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : follow_path(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_of_cmds = 0l;
      this->time_step = 0.0;
    }
  }

  explicit GetCmdList_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : follow_path(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->number_of_cmds = 0l;
      this->time_step = 0.0;
    }
  }

  // field types and members
  using _number_of_cmds_type =
    int32_t;
  _number_of_cmds_type number_of_cmds;
  using _time_step_type =
    double;
  _time_step_type time_step;
  using _follow_path_type =
    kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator>;
  _follow_path_type follow_path;

  // setters for named parameter idiom
  Type & set__number_of_cmds(
    const int32_t & _arg)
  {
    this->number_of_cmds = _arg;
    return *this;
  }
  Type & set__time_step(
    const double & _arg)
  {
    this->time_step = _arg;
    return *this;
  }
  Type & set__follow_path(
    const kompass_interfaces::msg::FollowPathRequest_<ContainerAllocator> & _arg)
  {
    this->follow_path = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__GetCmdList_Request
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__GetCmdList_Request
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetCmdList_Request_ & other) const
  {
    if (this->number_of_cmds != other.number_of_cmds) {
      return false;
    }
    if (this->time_step != other.time_step) {
      return false;
    }
    if (this->follow_path != other.follow_path) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetCmdList_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetCmdList_Request_

// alias to use template instance with default allocator
using GetCmdList_Request =
  kompass_interfaces::srv::GetCmdList_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'cmd_list'
#include "kompass_interfaces/msg/detail/twist_array__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__GetCmdList_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__GetCmdList_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetCmdList_Response_
{
  using Type = GetCmdList_Response_<ContainerAllocator>;

  explicit GetCmdList_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cmd_list(_init)
  {
    (void)_init;
  }

  explicit GetCmdList_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : cmd_list(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _cmd_list_type =
    kompass_interfaces::msg::TwistArray_<ContainerAllocator>;
  _cmd_list_type cmd_list;

  // setters for named parameter idiom
  Type & set__cmd_list(
    const kompass_interfaces::msg::TwistArray_<ContainerAllocator> & _arg)
  {
    this->cmd_list = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__GetCmdList_Response
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__GetCmdList_Response
    std::shared_ptr<kompass_interfaces::srv::GetCmdList_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetCmdList_Response_ & other) const
  {
    if (this->cmd_list != other.cmd_list) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetCmdList_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetCmdList_Response_

// alias to use template instance with default allocator
using GetCmdList_Response =
  kompass_interfaces::srv::GetCmdList_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace srv
{

struct GetCmdList
{
  using Request = kompass_interfaces::srv::GetCmdList_Request;
  using Response = kompass_interfaces::srv::GetCmdList_Response;
};

}  // namespace srv

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__GET_CMD_LIST__STRUCT_HPP_
