// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from kompass_interfaces:srv/PathFromToFile.idl
// generated code does not contain a copyright notice
#include "kompass_interfaces/srv/detail/path_from_to_file__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `file_location`
// Member `file_name`
#include "rosidl_runtime_c/string_functions.h"

bool
kompass_interfaces__srv__PathFromToFile_Request__init(kompass_interfaces__srv__PathFromToFile_Request * msg)
{
  if (!msg) {
    return false;
  }
  // file_location
  if (!rosidl_runtime_c__String__init(&msg->file_location)) {
    kompass_interfaces__srv__PathFromToFile_Request__fini(msg);
    return false;
  }
  // file_name
  if (!rosidl_runtime_c__String__init(&msg->file_name)) {
    kompass_interfaces__srv__PathFromToFile_Request__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__srv__PathFromToFile_Request__fini(kompass_interfaces__srv__PathFromToFile_Request * msg)
{
  if (!msg) {
    return;
  }
  // file_location
  rosidl_runtime_c__String__fini(&msg->file_location);
  // file_name
  rosidl_runtime_c__String__fini(&msg->file_name);
}

bool
kompass_interfaces__srv__PathFromToFile_Request__are_equal(const kompass_interfaces__srv__PathFromToFile_Request * lhs, const kompass_interfaces__srv__PathFromToFile_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // file_location
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->file_location), &(rhs->file_location)))
  {
    return false;
  }
  // file_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->file_name), &(rhs->file_name)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__srv__PathFromToFile_Request__copy(
  const kompass_interfaces__srv__PathFromToFile_Request * input,
  kompass_interfaces__srv__PathFromToFile_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // file_location
  if (!rosidl_runtime_c__String__copy(
      &(input->file_location), &(output->file_location)))
  {
    return false;
  }
  // file_name
  if (!rosidl_runtime_c__String__copy(
      &(input->file_name), &(output->file_name)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__srv__PathFromToFile_Request *
kompass_interfaces__srv__PathFromToFile_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__PathFromToFile_Request * msg = (kompass_interfaces__srv__PathFromToFile_Request *)allocator.allocate(sizeof(kompass_interfaces__srv__PathFromToFile_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__srv__PathFromToFile_Request));
  bool success = kompass_interfaces__srv__PathFromToFile_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__srv__PathFromToFile_Request__destroy(kompass_interfaces__srv__PathFromToFile_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__srv__PathFromToFile_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__srv__PathFromToFile_Request__Sequence__init(kompass_interfaces__srv__PathFromToFile_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__PathFromToFile_Request * data = NULL;

  if (size) {
    data = (kompass_interfaces__srv__PathFromToFile_Request *)allocator.zero_allocate(size, sizeof(kompass_interfaces__srv__PathFromToFile_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__srv__PathFromToFile_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__srv__PathFromToFile_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__srv__PathFromToFile_Request__Sequence__fini(kompass_interfaces__srv__PathFromToFile_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__srv__PathFromToFile_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__srv__PathFromToFile_Request__Sequence *
kompass_interfaces__srv__PathFromToFile_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__PathFromToFile_Request__Sequence * array = (kompass_interfaces__srv__PathFromToFile_Request__Sequence *)allocator.allocate(sizeof(kompass_interfaces__srv__PathFromToFile_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__srv__PathFromToFile_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__srv__PathFromToFile_Request__Sequence__destroy(kompass_interfaces__srv__PathFromToFile_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__srv__PathFromToFile_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__srv__PathFromToFile_Request__Sequence__are_equal(const kompass_interfaces__srv__PathFromToFile_Request__Sequence * lhs, const kompass_interfaces__srv__PathFromToFile_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__srv__PathFromToFile_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__srv__PathFromToFile_Request__Sequence__copy(
  const kompass_interfaces__srv__PathFromToFile_Request__Sequence * input,
  kompass_interfaces__srv__PathFromToFile_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__srv__PathFromToFile_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__srv__PathFromToFile_Request * data =
      (kompass_interfaces__srv__PathFromToFile_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__srv__PathFromToFile_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__srv__PathFromToFile_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__srv__PathFromToFile_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `global_path`
#include "nav_msgs/msg/detail/path__functions.h"

bool
kompass_interfaces__srv__PathFromToFile_Response__init(kompass_interfaces__srv__PathFromToFile_Response * msg)
{
  if (!msg) {
    return false;
  }
  // path_length
  // global_path
  if (!nav_msgs__msg__Path__init(&msg->global_path)) {
    kompass_interfaces__srv__PathFromToFile_Response__fini(msg);
    return false;
  }
  return true;
}

void
kompass_interfaces__srv__PathFromToFile_Response__fini(kompass_interfaces__srv__PathFromToFile_Response * msg)
{
  if (!msg) {
    return;
  }
  // path_length
  // global_path
  nav_msgs__msg__Path__fini(&msg->global_path);
}

bool
kompass_interfaces__srv__PathFromToFile_Response__are_equal(const kompass_interfaces__srv__PathFromToFile_Response * lhs, const kompass_interfaces__srv__PathFromToFile_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // path_length
  if (lhs->path_length != rhs->path_length) {
    return false;
  }
  // global_path
  if (!nav_msgs__msg__Path__are_equal(
      &(lhs->global_path), &(rhs->global_path)))
  {
    return false;
  }
  return true;
}

bool
kompass_interfaces__srv__PathFromToFile_Response__copy(
  const kompass_interfaces__srv__PathFromToFile_Response * input,
  kompass_interfaces__srv__PathFromToFile_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // path_length
  output->path_length = input->path_length;
  // global_path
  if (!nav_msgs__msg__Path__copy(
      &(input->global_path), &(output->global_path)))
  {
    return false;
  }
  return true;
}

kompass_interfaces__srv__PathFromToFile_Response *
kompass_interfaces__srv__PathFromToFile_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__PathFromToFile_Response * msg = (kompass_interfaces__srv__PathFromToFile_Response *)allocator.allocate(sizeof(kompass_interfaces__srv__PathFromToFile_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(kompass_interfaces__srv__PathFromToFile_Response));
  bool success = kompass_interfaces__srv__PathFromToFile_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
kompass_interfaces__srv__PathFromToFile_Response__destroy(kompass_interfaces__srv__PathFromToFile_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    kompass_interfaces__srv__PathFromToFile_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
kompass_interfaces__srv__PathFromToFile_Response__Sequence__init(kompass_interfaces__srv__PathFromToFile_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__PathFromToFile_Response * data = NULL;

  if (size) {
    data = (kompass_interfaces__srv__PathFromToFile_Response *)allocator.zero_allocate(size, sizeof(kompass_interfaces__srv__PathFromToFile_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = kompass_interfaces__srv__PathFromToFile_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        kompass_interfaces__srv__PathFromToFile_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
kompass_interfaces__srv__PathFromToFile_Response__Sequence__fini(kompass_interfaces__srv__PathFromToFile_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      kompass_interfaces__srv__PathFromToFile_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

kompass_interfaces__srv__PathFromToFile_Response__Sequence *
kompass_interfaces__srv__PathFromToFile_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  kompass_interfaces__srv__PathFromToFile_Response__Sequence * array = (kompass_interfaces__srv__PathFromToFile_Response__Sequence *)allocator.allocate(sizeof(kompass_interfaces__srv__PathFromToFile_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = kompass_interfaces__srv__PathFromToFile_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
kompass_interfaces__srv__PathFromToFile_Response__Sequence__destroy(kompass_interfaces__srv__PathFromToFile_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    kompass_interfaces__srv__PathFromToFile_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
kompass_interfaces__srv__PathFromToFile_Response__Sequence__are_equal(const kompass_interfaces__srv__PathFromToFile_Response__Sequence * lhs, const kompass_interfaces__srv__PathFromToFile_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!kompass_interfaces__srv__PathFromToFile_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
kompass_interfaces__srv__PathFromToFile_Response__Sequence__copy(
  const kompass_interfaces__srv__PathFromToFile_Response__Sequence * input,
  kompass_interfaces__srv__PathFromToFile_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(kompass_interfaces__srv__PathFromToFile_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    kompass_interfaces__srv__PathFromToFile_Response * data =
      (kompass_interfaces__srv__PathFromToFile_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!kompass_interfaces__srv__PathFromToFile_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          kompass_interfaces__srv__PathFromToFile_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!kompass_interfaces__srv__PathFromToFile_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
