// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:srv/PlanPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__STRUCT_HPP_
#define KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'start'
// Member 'goal'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__PlanPath_Request __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__PlanPath_Request __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct PlanPath_Request_
{
  using Type = PlanPath_Request_<ContainerAllocator>;

  explicit PlanPath_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_init),
    goal(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->from_robot_pose = false;
    }
  }

  explicit PlanPath_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_alloc, _init),
    goal(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->from_robot_pose = false;
    }
  }

  // field types and members
  using _start_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _start_type start;
  using _goal_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _goal_type goal;
  using _from_robot_pose_type =
    bool;
  _from_robot_pose_type from_robot_pose;

  // setters for named parameter idiom
  Type & set__start(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->start = _arg;
    return *this;
  }
  Type & set__goal(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->goal = _arg;
    return *this;
  }
  Type & set__from_robot_pose(
    const bool & _arg)
  {
    this->from_robot_pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__PlanPath_Request
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__PlanPath_Request
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PlanPath_Request_ & other) const
  {
    if (this->start != other.start) {
      return false;
    }
    if (this->goal != other.goal) {
      return false;
    }
    if (this->from_robot_pose != other.from_robot_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const PlanPath_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PlanPath_Request_

// alias to use template instance with default allocator
using PlanPath_Request =
  kompass_interfaces::srv::PlanPath_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces


// Include directives for member types
// Member 'plan'
#include "nav_msgs/msg/detail/path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__srv__PlanPath_Response __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__srv__PlanPath_Response __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct PlanPath_Response_
{
  using Type = PlanPath_Response_<ContainerAllocator>;

  explicit PlanPath_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : plan(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  explicit PlanPath_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : plan(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _plan_type =
    nav_msgs::msg::Path_<ContainerAllocator>;
  _plan_type plan;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__plan(
    const nav_msgs::msg::Path_<ContainerAllocator> & _arg)
  {
    this->plan = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__srv__PlanPath_Response
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__srv__PlanPath_Response
    std::shared_ptr<kompass_interfaces::srv::PlanPath_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PlanPath_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->plan != other.plan) {
      return false;
    }
    return true;
  }
  bool operator!=(const PlanPath_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PlanPath_Response_

// alias to use template instance with default allocator
using PlanPath_Response =
  kompass_interfaces::srv::PlanPath_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace kompass_interfaces

namespace kompass_interfaces
{

namespace srv
{

struct PlanPath
{
  using Request = kompass_interfaces::srv::PlanPath_Request;
  using Response = kompass_interfaces::srv::PlanPath_Response;
};

}  // namespace srv

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__SRV__DETAIL__PLAN_PATH__STRUCT_HPP_
