// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from kompass_interfaces:action/PlanPath.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__BUILDER_HPP_
#define KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "kompass_interfaces/action/detail/plan_path__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_Goal_end_tolerance
{
public:
  explicit Init_PlanPath_Goal_end_tolerance(::kompass_interfaces::action::PlanPath_Goal & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::PlanPath_Goal end_tolerance(::kompass_interfaces::action::PlanPath_Goal::_end_tolerance_type arg)
  {
    msg_.end_tolerance = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_Goal msg_;
};

class Init_PlanPath_Goal_algorithm_name
{
public:
  explicit Init_PlanPath_Goal_algorithm_name(::kompass_interfaces::action::PlanPath_Goal & msg)
  : msg_(msg)
  {}
  Init_PlanPath_Goal_end_tolerance algorithm_name(::kompass_interfaces::action::PlanPath_Goal::_algorithm_name_type arg)
  {
    msg_.algorithm_name = std::move(arg);
    return Init_PlanPath_Goal_end_tolerance(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_Goal msg_;
};

class Init_PlanPath_Goal_goal
{
public:
  Init_PlanPath_Goal_goal()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_Goal_algorithm_name goal(::kompass_interfaces::action::PlanPath_Goal::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return Init_PlanPath_Goal_algorithm_name(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_Goal msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_Goal>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_Goal_goal();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_Result_reached_end
{
public:
  explicit Init_PlanPath_Result_reached_end(::kompass_interfaces::action::PlanPath_Result & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::PlanPath_Result reached_end(::kompass_interfaces::action::PlanPath_Result::_reached_end_type arg)
  {
    msg_.reached_end = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_Result msg_;
};

class Init_PlanPath_Result_end_displacement
{
public:
  Init_PlanPath_Result_end_displacement()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_Result_reached_end end_displacement(::kompass_interfaces::action::PlanPath_Result::_end_displacement_type arg)
  {
    msg_.end_displacement = std::move(arg);
    return Init_PlanPath_Result_reached_end(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_Result msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_Result>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_Result_end_displacement();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_Feedback_plan
{
public:
  Init_PlanPath_Feedback_plan()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::kompass_interfaces::action::PlanPath_Feedback plan(::kompass_interfaces::action::PlanPath_Feedback::_plan_type arg)
  {
    msg_.plan = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_Feedback msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_Feedback>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_Feedback_plan();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_SendGoal_Request_goal
{
public:
  explicit Init_PlanPath_SendGoal_Request_goal(::kompass_interfaces::action::PlanPath_SendGoal_Request & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::PlanPath_SendGoal_Request goal(::kompass_interfaces::action::PlanPath_SendGoal_Request::_goal_type arg)
  {
    msg_.goal = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_SendGoal_Request msg_;
};

class Init_PlanPath_SendGoal_Request_goal_id
{
public:
  Init_PlanPath_SendGoal_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_SendGoal_Request_goal goal_id(::kompass_interfaces::action::PlanPath_SendGoal_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_PlanPath_SendGoal_Request_goal(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_SendGoal_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_SendGoal_Request>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_SendGoal_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_SendGoal_Response_stamp
{
public:
  explicit Init_PlanPath_SendGoal_Response_stamp(::kompass_interfaces::action::PlanPath_SendGoal_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::PlanPath_SendGoal_Response stamp(::kompass_interfaces::action::PlanPath_SendGoal_Response::_stamp_type arg)
  {
    msg_.stamp = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_SendGoal_Response msg_;
};

class Init_PlanPath_SendGoal_Response_accepted
{
public:
  Init_PlanPath_SendGoal_Response_accepted()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_SendGoal_Response_stamp accepted(::kompass_interfaces::action::PlanPath_SendGoal_Response::_accepted_type arg)
  {
    msg_.accepted = std::move(arg);
    return Init_PlanPath_SendGoal_Response_stamp(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_SendGoal_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_SendGoal_Response>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_SendGoal_Response_accepted();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_GetResult_Request_goal_id
{
public:
  Init_PlanPath_GetResult_Request_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  ::kompass_interfaces::action::PlanPath_GetResult_Request goal_id(::kompass_interfaces::action::PlanPath_GetResult_Request::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_GetResult_Request msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_GetResult_Request>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_GetResult_Request_goal_id();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_GetResult_Response_result
{
public:
  explicit Init_PlanPath_GetResult_Response_result(::kompass_interfaces::action::PlanPath_GetResult_Response & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::PlanPath_GetResult_Response result(::kompass_interfaces::action::PlanPath_GetResult_Response::_result_type arg)
  {
    msg_.result = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_GetResult_Response msg_;
};

class Init_PlanPath_GetResult_Response_status
{
public:
  Init_PlanPath_GetResult_Response_status()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_GetResult_Response_result status(::kompass_interfaces::action::PlanPath_GetResult_Response::_status_type arg)
  {
    msg_.status = std::move(arg);
    return Init_PlanPath_GetResult_Response_result(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_GetResult_Response msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_GetResult_Response>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_GetResult_Response_status();
}

}  // namespace kompass_interfaces


namespace kompass_interfaces
{

namespace action
{

namespace builder
{

class Init_PlanPath_FeedbackMessage_feedback
{
public:
  explicit Init_PlanPath_FeedbackMessage_feedback(::kompass_interfaces::action::PlanPath_FeedbackMessage & msg)
  : msg_(msg)
  {}
  ::kompass_interfaces::action::PlanPath_FeedbackMessage feedback(::kompass_interfaces::action::PlanPath_FeedbackMessage::_feedback_type arg)
  {
    msg_.feedback = std::move(arg);
    return std::move(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_FeedbackMessage msg_;
};

class Init_PlanPath_FeedbackMessage_goal_id
{
public:
  Init_PlanPath_FeedbackMessage_goal_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_PlanPath_FeedbackMessage_feedback goal_id(::kompass_interfaces::action::PlanPath_FeedbackMessage::_goal_id_type arg)
  {
    msg_.goal_id = std::move(arg);
    return Init_PlanPath_FeedbackMessage_feedback(msg_);
  }

private:
  ::kompass_interfaces::action::PlanPath_FeedbackMessage msg_;
};

}  // namespace builder

}  // namespace action

template<typename MessageType>
auto build();

template<>
inline
auto build<::kompass_interfaces::action::PlanPath_FeedbackMessage>()
{
  return kompass_interfaces::action::builder::Init_PlanPath_FeedbackMessage_goal_id();
}

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__ACTION__DETAIL__PLAN_PATH__BUILDER_HPP_
