// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from kompass_interfaces:msg/PathTrackingErrorArray.idl
// generated code does not contain a copyright notice

#ifndef KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR_ARRAY__STRUCT_HPP_
#define KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__kompass_interfaces__msg__PathTrackingErrorArray __attribute__((deprecated))
#else
# define DEPRECATED__kompass_interfaces__msg__PathTrackingErrorArray __declspec(deprecated)
#endif

namespace kompass_interfaces
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathTrackingErrorArray_
{
  using Type = PathTrackingErrorArray_<ContainerAllocator>;

  explicit PathTrackingErrorArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit PathTrackingErrorArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _orientation_errors_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _orientation_errors_type orientation_errors;
  using _lateral_distance_errors_type =
    std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>>;
  _lateral_distance_errors_type lateral_distance_errors;

  // setters for named parameter idiom
  Type & set__orientation_errors(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->orientation_errors = _arg;
    return *this;
  }
  Type & set__lateral_distance_errors(
    const std::vector<double, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<double>> & _arg)
  {
    this->lateral_distance_errors = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__kompass_interfaces__msg__PathTrackingErrorArray
    std::shared_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__kompass_interfaces__msg__PathTrackingErrorArray
    std::shared_ptr<kompass_interfaces::msg::PathTrackingErrorArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathTrackingErrorArray_ & other) const
  {
    if (this->orientation_errors != other.orientation_errors) {
      return false;
    }
    if (this->lateral_distance_errors != other.lateral_distance_errors) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathTrackingErrorArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathTrackingErrorArray_

// alias to use template instance with default allocator
using PathTrackingErrorArray =
  kompass_interfaces::msg::PathTrackingErrorArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace kompass_interfaces

#endif  // KOMPASS_INTERFACES__MSG__DETAIL__PATH_TRACKING_ERROR_ARRAY__STRUCT_HPP_
